// ---------------------------------------------------------------------------
//
//      The ab-initio based multiscale library
//
//                  S / P H I / n X
//
//      Copyright:  Max-Planck-Institute for Iron Research
//                  40237 Duesseldorf, Germany
//
//      Contact:    https://sxlib.mpie.de
//      Authors:    see sphinx/AUTHORS
//      License:    see sphinx/LICENSE
//
// ---------------------------------------------------------------------------

#ifndef _SX_FS_CONFIGURE_ACTION_H_
#define _SX_FS_CONFIGURE_ACTION_H_

// Including header-files
#include <SxFS.h>
#include <SxFileInfo.h>
#include <SxException.h>

/**
  \brief Contains class-functions for synchronization.

  \author Thomas Uchdorf, t.uchdorf@mpie.de
 */
class SX_EXPORT_FS SxFSConfigureAction
{
   public:
      SxFSConfigureAction ();
      ~SxFSConfigureAction ();

      static void syncUIDAndGIDAndTimes (const SxFileInfo &src,
                                         const SxFileInfo &dest);

   protected:

      static void syncTimes (const SxFileInfo &src,
                             const SxFileInfo &dest);
};

#endif /* _SX_FS_CONFIGURE_ACTION_H_ */
