// ---------------------------------------------------------------------------
//
//      The ab-initio based multiscale library
//
//                  S / P H I / n X
//
//      Copyright:  Max-Planck-Institute for Iron Research
//                  40237 Duesseldorf, Germany
//
//      Contact:    https://sxlib.mpie.de
//      Authors:    see sphinx/AUTHORS
//      License:    see sphinx/LICENSE
//
// ---------------------------------------------------------------------------

#include <SxUtil.h>
#include <SxPluginManager.h>
// --- define the common plugin base (our plugin API)
#include "plugins/SxDemoPluginBase.h"


/**  \author  Sixten Boeck  */
int main ()
{
   // --- prepare plugin manager and load list of plugins
   //     note: only the plugin list is loaded, not the plugins themselves
   SxPluginManager pluginMgr;
   pluginMgr.updatePluginList (SxList<SxString>() << "plugins/.libs");
   pluginMgr.print ();

   // --- load and execute plugin A
try {
   SxPtr<SxDemoPluginBase> plugin = pluginMgr.create<SxDemoPluginBase> ("SxPluginA");
   plugin->foo ();

   // --- unload plugin A (thanks to SxPtr), load and execute plugin A
   plugin = pluginMgr.create<SxDemoPluginBase> ("SxPluginB");
   plugin->foo ();
} catch (SxException e)  {
   e.print ();
}

   return 0;
}
