// ---------------------------------------------------------------------------
//
//      The ab-initio based multiscale library
//
//                  S / P H I / n X
//
//      Copyright:  Max-Planck-Institute for Iron Research
//                  40237 Duesseldorf, Germany
//
//      Contact:    https://sxlib.mpie.de
//      Authors:    see sphinx/AUTHORS
//      License:    see sphinx/LICENSE
//
// ---------------------------------------------------------------------------

#ifndef _SX_SINGLETON_H_
#define _SX_SINGLETON_H_

#include <SxPtr.h>

/** \brief ...

    \b SxClass = S/PHI/nX ...

    ....

    \author Sixten Boeck, boeck@mpie.de */
template<class T>
class SxSingleton
{
   public:

      static T &getObj ();
      static SxPtr<T> &getObjPtr ();

      static void destroyKeyCB (void *);

};


#include <SxSingleton.hpp>

#endif /* _SX_SINGLETON_H_ */
