// ---------------------------------------------------------------------------
//
//      The ab-initio based multiscale library
//
//                  S / P H I / n X
//
//      Copyright:  Max-Planck-Institute for Iron Research
//                  40237 Duesseldorf, Germany
//
//      Contact:    https://sxlib.mpie.de
//      Authors:    see sphinx/AUTHORS
//      License:    see sphinx/LICENSE
//
// ---------------------------------------------------------------------------

#include <SxThread.h>
#include <SxThreadPool.h>
#include <SxError.h>
#include <SxTime.h>

SxThread::SxThread ()
   : SxProcUnit ()
{
   // empty
}


//SxThread::SxThread (const SxPtr<SxProcUnitGroup> &group_)
//   : SxProcUnit (group_)
//{
//   // empty
//}


SxThread::~SxThread ()
{
   // empty
}


void SxThread::start ()
{
   SxThreadPool::getGlobalObj().submit (getThis ());
}


void SxThread::wait ()
{
   SxThreadPool::getGlobalObj().wait (this);
}


void SxThread::terminate ()
{
   SX_EXIT;
}


bool SxThread::isRunning () const
{
   return SxThreadPool::getGlobalObj().isRunning (this);
}


void SxThread::sleep (unsigned int seconds)
{
   millisleep (1000L * (unsigned long)seconds);
}


void SxThread::millisleep (unsigned long mseconds)
{
   SxTime::msleep (mseconds);
}



void SxThread::main ()
{
   SX_EXIT;  // this function is not pure abstract to allow static linkage
}


void SxThread::mainWrap ()
{
   sigStarted.send (this);
   main ();
   sigFinished.send (this);
}
