// ---------------------------------------------------------------------------
//
//      The ab-initio based multiscale library
//
//                  S / P H I / n X
//
//      Copyright:  Max-Planck-Institute for Iron Research
//                  40237 Duesseldorf, Germany
//
//      Contact:    https://sxlib.mpie.de
//      Authors:    see sphinx/AUTHORS
//      License:    see sphinx/LICENSE
//
// ---------------------------------------------------------------------------
#ifndef _SX_IDX_H_
#define _SX_IDX_H_

#include <SxUtil.h>

/**
  @ingroup Numerics
  */
class SxIdx
{
   public:
      int start;
      int end;

      inline SxIdx ()                    { start = end = 0; }
      inline SxIdx (int idx0, int idx1)  
      { 
         SX_CHECK_VARS (0 <= idx0 && idx0 <= idx1, idx0, idx1);
         start = idx0; end = idx1; 
      }
};

#endif /* _SX_IDX_H_ */
