// ---------------------------------------------------------------------------
//
//      The ab-initio based multiscale library
//
//                  S / P H I / n X
//
//      Copyright:  Max-Planck-Institute for Iron Research
//                  40237 Duesseldorf, Germany
//
//      Contact:    https://sxlib.mpie.de
//      Authors:    see sphinx/AUTHORS
//      License:    see sphinx/LICENSE
//
// ---------------------------------------------------------------------------

#ifndef _SX_SYM_MATRIX_H_
#define _SX_SYM_MATRIX_H_

#include <SxVector.h>
#include <SxMatrix.h>
#include <SxPrecision.h>

#ifdef SXMATBASIS
#   undef SXMATBASIS
#endif
#define SXMATBASIS  SxVector

#ifdef SXSYMMAT
#   undef SXSYMMAT
#endif
#define SXSYMMAT    SxMatrix


#ifdef SXSYMMAT
#   undef SXSYMMAT
#endif
#define SXSYMMAT    SxSymMatrix

#ifdef MEMHANDLE
#   undef MEMHANDLE
#endif
#define MEMHANDLE    SxVectorHandle

#include <SxSymMat.h>

#endif /* _SX_SYM_MATRIX_H_ */
