#include <stdio.h>
#include <SxString.h>
#include <SxSigSlots.h>
#include <SxCLI.h>

class MySlider
{
   public:
      MySlider () { }

   signals:

      SxSignal<double, const char*> SX_SIGNAL(valueChanged);
};



class MyIsosurface
{
   public:
      MyIsosurface () { }

   public slots:
 
      void slotGenerate (double threshold, const char*)
      {
         printf ("MyIsosurface::slotGenerate received: %g\n", threshold);
      }

};


int main (int argc, char **argv)
{
   SxCLI cli (argc, argv);
   cli.finalize ();

   SxPtr<MySlider> slider     = SxPtr<MySlider>::create ();
   SxPtr<MyIsosurface> isoPtr = SxPtr<MyIsosurface>::create ();

   sxconnect (slider->valueChanged, isoPtr, MyIsosurface::slotGenerate);
//  sxdisconnect (slider->valueChanged, isoPtr, MyIsosurface::slotGenerate);
// slider->valueChanged.disconnect (isoPtr.getPtr(), &MyIsosurface::slotGenerate);

   SxPtr<MyIsosurface> isoPtr1 = isoPtr;
   isoPtr = SxPtr<MyIsosurface> ();

   slider->valueChanged.send (5.0);
   return 0;
}
